=== debian/changelog ===
cppad (2014.00.00.3-1) unstable; urgency=medium

  * Initial release (Closes: #742899)
    - Based on initial work by Barak A. Pearlmutter

 -- Miles Lubin <miles.lubin@gmail.com>  Tue, 08 Apr 2014 15:27:03 +0100
